
package TimeTravel
{
  import flash.display.*;
  import flash.events.*;
  import UserInterface.*;
  
  public class BackstoryChapter extends FilteredSprite implements Chapter
  {
    private var ob:FilteredSprite = null;
    private var tf:EasyTextField = null;
    private var theStage:Stage;
    
    public function BackstoryChapter(stage:Stage, background:Boolean = false, imageName:String = "tt-backstory")
    {
      this.theStage = stage;
      if (background) addChild(new MainMenuBackground(stage));

      ob = Sprites.createNamedSprite(imageName);
      addChild(ob);
      ob.x = 0.5*theStage.stageWidth;
      ob.y = 0.5*theStage.stageHeight;
      ob.shadowOn = true;
      ob.updateFilters();
      
      var ib:ImageButton = new ImageButton(16, 16, 24);
      ib.x = -0.5*ob.width + 8;
      ib.y = -0.5*ob.height + 8;
      var ibs:FilteredSprite = Sprites.createNamedSprite("close-button");
      ibs.shadowOn = true;
      ibs.updateFilters();
      ibs.x = ib.x + 8;
      ibs.y = ib.y + 8;
      ob.addChild(ibs);
      ob.addChild(ib);
      ib.addEventListener(MouseEvent.CLICK, clickMenuButton);
    }
    
    function clickMenuButton(event:Event)
    {
      SoundAssets.playSound("r-plastic", 0.5);
      this.dispatchEvent(new Event(TTApp.RETURN_TO_MENU));
    }

    var chapterParent:Sprite;
    
    public function addToParent(sprite:Sprite):void
    {
      chapterParent = sprite;
      chapterParent.addChild(this);
    }

    public function getParent():Sprite
    {
      return chapterParent;
    }

    public function getDisplay():Sprite
    {
      return this;
    }
    
    public function makeActive():void
    {
      LevelManager.backstoryViewed = true;
    }

    public function makeInactive():void
    {
    }

    public function removeFromParent():void
    {
      chapterParent.removeChild(this);
      chapterParent = null;
    }
  }
}

