
package TimeTravel
{
  import flash.display.Sprite;
  import flash.events.*;
  
  public class ClockSprite extends FilteredSprite
  {
    private static var minuteHandAngle:Number = -62.5;
    private static var hourHandAngle:Number = 57.5;
    private static var minuteHandCenter:Array = [-77, 39];
    private static var hourHandCenter:Array = [53, 32];

    private var clock:FilteredSprite = Sprites.createNamedSprite("clock-no-hands");
    public var minuteHand:FilteredSprite = Sprites.createNamedSprite("clock-big-hand");
    public var hourHand:FilteredSprite = Sprites.createNamedSprite("clock-little-hand");
    private var time:int = 0;
    private var timeDir:int = 1;
    private var rotationRate:int = 0;
    public var vy:int = 0;
    public var maxy:int = 400;
    
    public function ClockSprite()
    {
      addChild(clock);
      addChild(hourHand);
      addChild(minuteHand);
      setTime(time);
      addEventListener(Event.ENTER_FRAME, tick);
    }

    public function setRotationRate(rate:int)
    {
      rotationRate = rate;
    }

    public function setTime(time:int)
    {
      var hrs:Number = time / 60.0;
      var min:int = time % 60;
      
      var ang:Number = 6 * min + minuteHandAngle;
      var cs:Number = Math.cos(ang * Math.PI/180.0);
      var sn:Number = Math.sin(ang * Math.PI/180.0);

      minuteHand.rotation = ang;
      minuteHand.x = - minuteHandCenter[0]*cs + minuteHandCenter[1]*sn;
      minuteHand.y = - minuteHandCenter[0]*sn - minuteHandCenter[1]*cs;

      ang = 30 * hrs + hourHandAngle;
      cs = Math.cos(ang * Math.PI/180.0);
      sn = Math.sin(ang * Math.PI/180.0);

      hourHand.rotation = ang;
      hourHand.x = - hourHandCenter[0]*cs + hourHandCenter[1]*sn;
      hourHand.y = - hourHandCenter[0]*sn - hourHandCenter[1]*cs;
    }

    function tick(event:Event)
    {
      if (Math.random() < 0.01)
      {
	if (timeDir < 0)
	{
	  minuteHand.glowColor = null;
	  hourHand.glowColor = null;
	  minuteHand.updateFilters();
	  hourHand.updateFilters();
	  if (rotationRate != 0)
	  {
	    this.glowColor = null;
	    this.updateFilters();
	  }
	  timeDir = 1;
	}
	else if (timeDir > 0)
	{
	  minuteHand.glowColor = "blue";
	  hourHand.glowColor = "blue";
	  minuteHand.updateFilters();
	  hourHand.updateFilters();
	  if (rotationRate != 0)
	  {
	    this.glowColor = "blue";
	    this.updateFilters();
	  }
	  timeDir = -2;
	}
      }
      this.rotation = (this.rotation + 360 + rotationRate*timeDir) % 360;
      this.y += (this.vy);
      if (this.y > this.maxy + 100) this.y = -100;
      time = (time + 720 + timeDir) % 720;
      setTime(time);
    }
  }
}

