
package TimeTravel
{
  import TimeTravel.Player;
  import TimeTravel.MazeSquare;
  import flash.filters.*;
   
  public class DoorCloseEvent implements WorldEvent
  {
    var at:MazeSquare;

    public function DoorCloseEvent(at:MazeSquare)
    {
      this.at = at;
    }

    private function showWorld(completion:Number)
    {
      if (at.contents == MazeSquare.DOOR)
      {
	at.doorSprite.fade = 0.25 + 0.75*completion;
	at.doorSprite.updateFilters();
      }
    }

    public function testWorldForward(maze:Maze):Array
    {
      if (at.doorSprite == null)
      {
         return [at, at, "???"];
      }
      return null;
    }

    public function beginWorldForward(maze:Maze) { showWorld(0.0); at.doorClosed = true; if (at.contents == MazeSquare.DOOR) SoundAssets.playSound("close-door", 0.5); }
    public function showWorldForward(maze:Maze, completion:Number) { showWorld(completion); }
    public function endWorldForward(maze:Maze) { showWorld(1.0); }
    public function beginWorldReverse(maze:Maze) { showWorld(1.0); }
    public function showWorldReverse(maze:Maze, completion:Number) { showWorld(completion); }
    public function endWorldReverse(maze:Maze) { showWorld(0.0); at.doorClosed = false; }
  }
}

