
package TimeTravel
{
  import TimeTravel.Player;
  import TimeTravel.MazeSquare;
  import flash.filters.*;
   
  public class DoorOpenEvent implements PlayerEvent, WorldEvent
  {
    var at:MazeSquare;
    var linkedWorldEvents:Array = new Array();

    public function DoorOpenEvent(at:MazeSquare)
    {
      this.at = at;
      linkWorldEvent(this);
    }

    public function linkWorldEvent(event:WorldEvent)
    {
      linkedWorldEvents.push(event);
    }

    public function getLinkedWorldEvents():Array
    {
      return linkedWorldEvents.slice();
    }

    public function beginPlayerForward(player:Player) { }
    public function showPlayerForward(player:Player, completion:Number) { }
    public function endPlayerForward(player:Player) { }
    public function beginPlayerReverse(player:Player) { }
    public function showPlayerReverse(player:Player, completion:Number) { }
    public function endPlayerReverse(player:Player) { }

    private function showWorld(completion:Number)
    {
      at.doorSprite.fade = 0.25 + 0.75*(1.0-completion);
      at.doorSprite.updateFilters();
    }

    public function testWorldForward(maze:Maze):Array
    {
      if (at.doorSprite == null || at.contents != MazeSquare.DOOR)
      {
         return [at, at, "???"];
      }
      return null;
    }

    public function beginWorldForward(maze:Maze) { showWorld(0.0); at.doorClosed = false; SoundAssets.playSound("open-door", 0.5); }
    public function showWorldForward(maze:Maze, completion:Number) { showWorld(completion); }
    public function endWorldForward(maze:Maze) { showWorld(1.0); }
    public function beginWorldReverse(maze:Maze) { showWorld(1.0); }
    public function showWorldReverse(maze:Maze, completion:Number) { showWorld(completion); }
    public function endWorldReverse(maze:Maze) { showWorld(0.0); at.doorClosed = true; }
  }
}

