
package TimeTravel
{
  public class EventHistory
  {
    var earliestTime:int = 0;
    var latestTime:int = 0;
    var history:Array = [[]];

    public function EventHistory()
    {
    }

    public function getLastEventTime():int
    {
      var maxTime:int = earliestTime;
      for (var i:int=earliestTime; i<=latestTime; ++i) if (history[i].length>0) maxTime = i;
      return i;
    }
    
    public function removeEvent(time:int, event:*):Boolean
    {
      var ret:Boolean = false;
      if (time>=earliestTime && time<=latestTime)
      {
        var ix:int = 0;
        while ((ix = history[time].indexOf(event, ix)) >= 0)
        {
          ret = true;
          history[time].splice(ix, 1);
        }
      }
      return ret;
    }

    public function addEvent(time:int, event:*)
    {
      var i:int;
      if (time < earliestTime)
      {
        for (i=time; i<earliestTime; ++i) history[i] = [];
        earliestTime = time;
      }
      if (time > latestTime)
      {
        for (i=time; i>latestTime; --i) history[i] = [];
        latestTime = time;
      }

      history[time].push(event);
    }

    public function prependEvent(time:int, event:*)
    {
      var i:int;
      if (time < earliestTime)
      {
        for (i=time; i<earliestTime; ++i) history[i] = [];
        earliestTime = time;
      }
      if (time > latestTime)
      {
        for (i=time; i>latestTime; --i) history[i] = [];
        latestTime = time;
      }

      var tmp:Array = history[time];
      history[time] = [event];
      for each (var e:* in tmp)
      {
	history[time].push(e);
      }
    }
    
    public function clearEvents(time:int)
    {
      if (time>=earliestTime && time<=latestTime) history[time] = [];
    }

    public function getEvents(time:int):Array
    {
      if (time>=earliestTime && time<=latestTime) return history[time].slice();
      return [];
    }

    public function getReversedEvents(time:int):Array
    {
      if (time>=earliestTime && time<=latestTime)
      {
        var ret:Array = history[time].slice();
        ret.reverse();
        return ret;
      }
      return [];
    }
  }
}

