
package TimeTravel
{
  import flash.filters.*;
  import flash.display.*;

  public class FilteredSprite extends Sprite
  {
    public var shadowOn:Boolean = true;
    public var blurX:int = 0;
    public var blurY:int = 0;
    public var glowColor:String = null;
    public var fade:Number = 1.0;

    private var dropShadowFilter:DropShadowFilter = new DropShadowFilter(4, 45);
    private var redGlowFilter:GlowFilter = new GlowFilter(0xFF0000, 1.0, 24, 24);
    private var greenGlowFilter:GlowFilter = new GlowFilter(0x00FF00, 1.0, 24, 24);
    private var blueGlowFilter:GlowFilter = new GlowFilter(0x0000FF, 1.0, 24, 24);

    private var glowFilters:Object = new Object();

    public function FilteredSprite()
    {
      super();

      glowFilters["red"] = redGlowFilter;
      glowFilters["green"] = greenGlowFilter;
      glowFilters["blue"] = blueGlowFilter;

      updateFilters();
    }

    public function updateFilters()
    {
      var array:Array = [];
      if (blurX > 0 || blurY > 0)
      {
        array.push(new BlurFilter(blurX, blurY, 2));
      }
      if (glowFilters[glowColor])
      {
        array.push(glowFilters[glowColor]);
      }
      if (shadowOn)
      {
        array.push(dropShadowFilter);
      }
      if (fade < 1.0)
      {
	var matrix:Array = new Array();
	matrix = matrix.concat([1, 0, 0, 0, 0]); // red
	matrix = matrix.concat([0, 1, 0, 0, 0]); // green
	matrix = matrix.concat([0, 0, 1, 0, 0]); // blue
	matrix = matrix.concat([0, 0, 0, fade, 0]); // alpha
	array.push(new ColorMatrixFilter(matrix));
      }
      this.filters = array;
    }
  }
}

