
package TimeTravel
{
  import flash.display.*;
  import flash.events.*;
  import UserInterface.*;
  
  public class Instructions extends FilteredSprite implements Chapter
  {
    private var ob:FilteredSprite = null;
    private var tf:EasyTextField = null;
    private var prevScreen:EasyButton = new EasyButton("<<<", 18, 0xFF0000, 0);
    private var nextScreen:EasyButton = new EasyButton(">>>", 18, 0xFF0000, 0);
    private var screen:String;
    private var theStage:Stage;
    
    public function Instructions(stage:Stage, background:Boolean = false)
    {
      this.theStage = stage;
      if (background) addChild(new MainMenuBackground(stage));

      prevScreen.addEventListener(MouseEvent.CLICK, clickPrevScreen);
      nextScreen.addEventListener(MouseEvent.CLICK, clickNextScreen);
      
      init("tt-gameplay", "Instructions");
      // init("tt-objects", "Game Objects");
    }

    private function init(screen:String, name:String)
    {
      if (ob != null) removeChild(ob);
      if (tf != null) removeChild(tf);
      this.screen = screen;
      
      ob = Sprites.createNamedSprite(screen);
      addChild(ob);
      ob.x = 0.5*theStage.stageWidth;
      ob.y = 0.5*theStage.stageHeight - 10;
      ob.graphics.beginFill(0xFFFFFF);
      ob.graphics.drawRect(-0.5*ob.width+1, -0.5*ob.height, ob.width-2, 32);
      ob.graphics.endFill();
      ob.graphics.lineStyle(1, 0x000000);
      ob.graphics.drawRect(-0.5*ob.width+1, -0.5*ob.height, ob.width-2, 32);
      ob.graphics.drawRect(-0.5*ob.width+1, -0.5*ob.height, ob.width-2, ob.height-1);
      ob.shadowOn = true;
      ob.updateFilters();

      tf = new EasyTextField(name, 24, 0xFF0000);
      addChild(tf);
      tf.setCoords(theStage.stageWidth / 2, ob.y - 0.5*ob.height + 5);

      var ib:ImageButton = new ImageButton(16, 16, 24);
      ib.x = -0.5*ob.width + 8;
      ib.y = -0.5*ob.height + 8;
      var ibs:FilteredSprite = Sprites.createNamedSprite("close-button");
      ibs.shadowOn = false;
      ibs.updateFilters();
      ibs.x = ib.x + 8;
      ibs.y = ib.y + 8;
      ob.addChild(ibs);
      ob.addChild(ib);
      ib.addEventListener(MouseEvent.CLICK, clickMenuButton);

      if (screen == "tt-gameplay")
      {
	addChild(nextScreen);
	nextScreen.x = tf.x + tf.width + 20;
	nextScreen.y = tf.y + tf.height / 2;
      }
      else if (screen == "tt-keys")
      {
	addChild(nextScreen);
	nextScreen.x = tf.x + tf.width + 20;
	nextScreen.y = tf.y + tf.height / 2;

	addChild(prevScreen);
	prevScreen.x = tf.x - prevScreen.width - 8;
	prevScreen.y = tf.y + tf.height / 2;
      }
      else if (screen == "tt-objects")
      {
	addChild(prevScreen);
	prevScreen.x = tf.x - prevScreen.width - 8;
	prevScreen.y = tf.y + tf.height / 2;
      }
    }
    
    function clickNextScreen(event:Event)
    {
      SoundAssets.playSound("release-click", 0.5);
      if (screen == "tt-gameplay") init("tt-keys", "Commands");
      else if (screen == "tt-keys") init("tt-objects", "Game Objects");
    }

    function clickPrevScreen(event:Event)
    {
      SoundAssets.playSound("release-click", 0.5);
      if (screen == "tt-objects") init("tt-keys", "Commands");
      else if (screen == "tt-keys") init("tt-gameplay", "Instructions");
    }
    
    function clickMenuButton(event:Event)
    {
      SoundAssets.playSound("r-plastic", 0.5);
      this.dispatchEvent(new Event(TTApp.RETURN_TO_MENU));
    }

    var chapterParent:Sprite;
    
    public function addToParent(sprite:Sprite):void
    {
      chapterParent = sprite;
      chapterParent.addChild(this);
    }

    public function getParent():Sprite
    {
      return chapterParent;
    }

    public function getDisplay():Sprite
    {
      return this;
    }
    
    public function makeActive():void
    {
    }

    public function makeInactive():void
    {
    }

    public function removeFromParent():void
    {
      chapterParent.removeChild(this);
      chapterParent = null;
    }
  }
}

