
package TimeTravel
{
  import UserInterface.*;
  import flash.display.*;
  import flash.text.*;
  import flash.filters.*;
  import flash.events.*;

  public class LevelSelector extends Sprite implements Chapter
  {
    public var selectedLevel:LevelInfo = null;
    private var bs:BackstoryChapter = null;
    
    public function LevelSelector(stage:Stage, firstLevel:int = 1)
    {
      var bg:Sprite = new Sprite();
      bg.graphics.beginFill(0xAAAAFF);
      bg.graphics.drawRect(0, 0, stage.stageWidth, stage.stageHeight);
      bg.graphics.endFill();
      addChild(bg);

      var ibs:TTApp;
      var ib:ImageButton;

      var tf:EasyTextField = new EasyTextField("Select Level", 24, 0xFF0000);
      addChild(tf);
      tf.setCoords(stage.stageWidth / 2, 30);
      
      var lm:LevelManager = LevelManager.getInstance();
      lm.setLevelSelector(this);

      var endOfEpisode:Boolean = false;
      
      for (var i:int=0; i<2; i++) for (var j:int=0; j<3; j++)
      {
	var ix:int = 3*i + j + firstLevel;
	
	if (ix > lm.numLevels()) { continue; }
	
	ibs = new TTApp(stage, lm.getLevel(ix), lm.isLevelAvailable(ix));
	ibs.width = 120;
	ibs.height = 100;
	ibs.x = (stage.stageWidth - 360)/4.0 + j*(120 + (stage.stageWidth - 360)/4.0);
	ibs.y = 50 + (stage.stageHeight - 200 - 50)/3.0 + i*(100 + (stage.stageHeight - 200 - 50)/3.0);
	if (j==0 || j==2) ibs.y -= 25;
	
	addChild(ibs);
	
	ib = new ImageButton(120, 100);
	ib.x = (stage.stageWidth - 360)/4.0 + j*(120 + (stage.stageWidth - 360)/4.0);
	ib.y = 50 + (stage.stageHeight - 200 - 50)/3.0 + i*(100 + (stage.stageHeight - 200 - 50)/3.0);
	if (j==0 || j==2) ib.y -= 25;
	addChild(ib);

	ib.addEventListener(MouseEvent.CLICK, lm.getLevel(ix).levelSelect);

	if (lm.isLevelComplete(ix)) {
	  var ksprite:FilteredSprite;
	  if (lm.isLevelNewlyComplete(ix)) {
	    ksprite = Sprites.createNamedSprite("new-green-check");
	    ksprite.glowColor = "green";
	    ksprite.updateFilters();
	    lm.setLevelComplete(ix, true);
	    SoundAssets.playSound("applause", 0.2, 100);

	    if (ix == 6)
	    {
	      endOfEpisode = true;
	    }
	  }
	  else {
	    ksprite = Sprites.createNamedSprite("green-check");
	  }

	  ksprite.x = ibs.x + 110;
	  ksprite.y = ibs.y + 80;
	      // ksprite.width = 36;
	      // ksprite.height = 36;
	  addChild(ksprite);
	}
	
	if (!lm.isLevelAvailable(ix)) {
	  var lsprite:Sprite = Sprites.createNamedSprite("locked-level");
	  lsprite.x = ibs.x + 60;
	  lsprite.y = ibs.y + 50;
	  lsprite.filters = [];
	  addChild(lsprite);

	  ibs.filters = [new BlurFilter(4, 4, 2)];
	  ib.enabled = false;
	}

	var tf2:EasyTextField;
	
	if (lm.isLevelAvailable(ix))
	{
	  tf2 = new EasyTextField(lm.getLevel(ix).name, 18, 0x000000);
	}
	else
	{
	  tf2 = new EasyTextField("?????", 18, 0x444444);
	}
	
	addChild(tf2);
	tf2.setCoords(ibs.x + 60, ibs.y + 105);
      }
      
      var menuButton:EasyButton = new EasyButton("BACK", 14, 0x000000, 4);
      menuButton.x = stage.stageWidth - 35;
      menuButton.y = stage.stageHeight - 25;
      addChild(menuButton);
      menuButton.addEventListener(MouseEvent.CLICK, clickMenuButton);

      if (endOfEpisode)
      {
	bs = new BackstoryChapter(stage, false, "tt-episode-one-end");
	addChild(bs);
	bs.addEventListener(TTApp.RETURN_TO_MENU, closeBalloon);
	SoundAssets.playSound("applause", 0.2, 0);
      }
      
      if (firstLevel > 1)
      {
	var prevLevels:EasyButton = new EasyButton("<<<", 18, 0xFF0000, 0);
	addChild(prevLevels);
	prevLevels.x = tf.x - prevLevels.width - 20;
	prevLevels.y = tf.y + tf.height / 2;
	prevLevels.addEventListener(MouseEvent.CLICK, clickPreviousLevels);
      }

      if (firstLevel + 5 < lm.numLevels())
      {
	var nextLevels:EasyButton = new EasyButton(">>>", 18, 0xFF0000, 0);
	addChild(nextLevels);
	nextLevels.x = tf.x + tf.width + 20;
	nextLevels.y = tf.y + tf.height / 2;
	nextLevels.addEventListener(MouseEvent.CLICK, clickNextLevels);
      }
    }
    
    function closeBalloon(event:Event)
    {
      if (bs != null) removeChild(bs);
      bs = null;
    }
    
    function clickNextLevels(event:Event)
    {
      SoundAssets.playSound("release-click", 0.5);
      this.dispatchEvent(new Event("next-levels"));
    }

    function clickPreviousLevels(event:Event)
    {
      SoundAssets.playSound("release-click", 0.5);
      this.dispatchEvent(new Event("previous-levels"));
    }
    
    function clickMenuButton(event:Event)
    {
      SoundAssets.playSound("r-plastic", 0.5);
      this.dispatchEvent(new Event(TTApp.RETURN_TO_MENU));
    }

    function levelSelect(event:Event)
    {
      SoundAssets.playSound("release-click", 0.5);
      this.dispatchEvent(new Event(TimeTravelMainMenu.SELECTION));
    }
    
    var chapterParent:Sprite;

    public function addToParent(sprite:Sprite):void
    {
      chapterParent = sprite;
      chapterParent.addChild(this);
    }

    public function getParent():Sprite
    {
      return chapterParent;
    }

    public function getDisplay():Sprite
    {
      return this;
    }

    public function makeActive():void
    {
    }

    public function makeInactive():void
    {
    }

    public function removeFromParent():void
    {
      chapterParent.removeChild(this);
      chapterParent = null;
    }
  }
}

