
package TimeTravel.Levels
{
  import TimeTravel.*;

  public class LevelRaceClock extends LevelInfo
  {
    public function LevelRaceClock()
    {
      super("Beat THE Clock 2", 9, 9);
    }

    public override function populateMaze(maze:Maze):Boolean
    {
      maze.setDisplaySize("medium");
      maze.displayUpperLeft[0] += 0.5 * maze.displayTileSize;
      
      maze.addSquare(0, 1);
      maze.setEntrance(0, 1, 1, 0);
      
      maze.addSquare(1, 1);
      maze.addSquare(2, 1);
      maze.addSquare(3, 1);
      maze.addSquare(4, 1);
      maze.addSquare(5, 1);
      maze.addSquare(6, 1);
      maze.addSquare(7, 1);
      maze.addSquare(7, 2);
      
      maze.getLocation(6, 1).keysNeeded = 999;
      maze.setContents(6, 1, MazeSquare.DOOR);
      maze.getLocation(6, 1).doorSprite.fade = 0.25;
      maze.getLocation(6, 1).doorSprite.updateFilters();
      maze.getLocation(6, 1).doorClosed = false;

      maze.getLocation(7, 2).keysNeeded = 999;
      maze.setContents(7, 2, MazeSquare.DOOR);
      // maze.getLocation(6, 1).doorSprite.fade = 0.25;
      // maze.getLocation(6, 1).doorSprite.updateFilters();
      maze.getLocation(7, 2).doorClosed = true;

      var doorClose:WorldEvent = new DoorCloseEvent(maze.getLocation(6, 1));
      maze.addEventToTime(doorClose, 4);
      
      doorClose = new DoorOpenEvent(maze.getLocation(7, 2));
      maze.addEventToTime(doorClose, 5);
      
      maze.addSquare(2, 2);
      maze.addSquare(5, 0);
      maze.setContents(5, 0, MazeSquare.WARP);
      
      maze.addSquare(7, 3);
      maze.addSquare(6, 3);
      maze.addSquare(5, 3);
      maze.addSquare(4, 3);
      maze.addSquare(4, 4);
      maze.addSquare(3, 4);
      maze.addSquare(2, 4);
      maze.addSquare(2, 5);
      maze.addSquare(2, 6);
      maze.addSquare(1, 5);
      maze.setContents(1, 5, MazeSquare.WARP);

      maze.addSquare(3, 6);
      maze.addSquare(4, 6);
      maze.addSquare(5, 6);
      maze.addSquare(6, 6);
      maze.addSquare(7, 6);
      maze.addSquare(8, 6);
      maze.setExit(8, 6, 1, 0);

      maze.getLocation(4, 6).keysNeeded = 999;
      maze.setContents(4, 6, MazeSquare.DOOR);
      maze.getLocation(4, 6).doorSprite.fade = 0.25;
      maze.getLocation(4, 6).doorSprite.updateFilters();
      maze.getLocation(4, 6).doorClosed = false;

      maze.getLocation(6, 6).keysNeeded = 999;
      maze.setContents(6, 6, MazeSquare.DOOR);
      maze.getLocation(6, 6).doorClosed = true;
      
      doorClose = new DoorCloseEvent(maze.getLocation(4, 6));
      maze.addEventToTime(doorClose, 10);
      
      doorClose = new DoorOpenEvent(maze.getLocation(6, 6));
      maze.addEventToTime(doorClose, 11);      
      
      maze.addSquare(7, 4);
      maze.setContents(7, 4, MazeSquare.BLOCK);
      
      return true;
    }
  }
}

