
package TimeTravel.Levels
{
  import TimeTravel.*;

  public class LevelRaceClockOne extends LevelInfo
  {
    public function LevelRaceClockOne()
    {
      super("Beat THE Clock", 6, 5);
    }

    public override function populateMaze(maze:Maze):Boolean
    {
      maze.displayUpperLeft[0] += 0.5 * maze.displayTileSize;
      maze.displayUpperLeft[1] -= 0.5 * maze.displayTileSize;

      maze.addSquare(4, 1);
      maze.setEntrance(4, 1, -1, 0);
      
      maze.addSquare(3, 1);
      maze.addSquare(2, 1);
      maze.addSquare(1, 1);
      maze.setContents(1, 1, MazeSquare.BLOCK);

      maze.addSquare(0, 1);
      maze.addSquare(1, 2);
      maze.addSquare(1, 3);
      maze.addSquare(1, 4);
      
      maze.addSquare(2, 4);
      maze.addSquare(3, 4);
      maze.addSquare(4, 4);
      maze.addSquare(5, 4);
      maze.addSquare(5, 3);

      maze.addSquare(3, 3);
      maze.setContents(3, 3, MazeSquare.WARP);

      maze.getLocation(4, 4).keysNeeded = 999;
      maze.setContents(4, 4, MazeSquare.DOOR);
      maze.getLocation(4, 4).doorSprite.fade = 0.25;
      maze.getLocation(4, 4).doorSprite.updateFilters();
      maze.getLocation(4, 4).doorClosed = false;
      
      var doorClose:DoorCloseEvent = new DoorCloseEvent(maze.getLocation(4, 4));
      maze.addEventToTime(doorClose, 4);
      
      maze.setExit(5, 3, 0, -1);
            
      return true;
    }
  }
}

