
package TimeTravel.Levels
{
  import TimeTravel.*;

  public class LevelTroubledHub extends LevelInfo
  {
    public function LevelTroubledHub()
    {
      super("tRoubled HUB", 8, 7);
    }

    public override function populateMaze(maze:Maze):Boolean
    {
      maze.setDisplaySize("medium");
      maze.displayUpperLeft[0] += maze.displayTileSize;
      
      maze.addSquare(0, 3);
      maze.setEntrance(0, 3, 1, 0);
      
      maze.addSquare(1, 3);
      maze.addSquare(2, 3);
      maze.addSquare(2, 2);
      maze.setContents(2, 2, MazeSquare.LIGHT_BLOCK);
      maze.addSquare(2, 4); // timed door 
      maze.addSquare(2, 5);
      maze.addSquare(1, 5); // 2-key door
      maze.addSquare(0, 5);
      maze.setExit(0, 5, -1, 0);
      
      maze.addSquare(3, 3);
      maze.addSquare(4, 3);
      maze.addSquare(5, 3);
      maze.addSquare(6, 3);
      maze.addSquare(7, 3);
      maze.addSquare(7, 2);
      maze.setContents(7, 2, MazeSquare.WARP);
            
      maze.addSquare(4, 4);
      maze.addSquare(4, 5);
      maze.addSquare(5, 5); // timed door
      maze.addSquare(5, 6);
      maze.setContents(5, 6, MazeSquare.KEY);
      
      maze.addSquare(4, 2);
      maze.addSquare(4, 1);
      maze.addSquare(5, 1); // timed door
      maze.addSquare(5, 0);
      maze.setContents(5, 0, MazeSquare.KEY);

      maze.getLocation(1, 5).keysNeeded = 2;
      maze.setContents(1, 5, MazeSquare.DOOR);
      maze.getLocation(1, 5).doorClosed = true;

      maze.getLocation(2, 4).keysNeeded = 999;
      maze.setContents(2, 4, MazeSquare.DOOR);
      maze.getLocation(2, 4).doorClosed = true;
            
      maze.getLocation(5, 1).keysNeeded = 999;
      maze.setContents(5, 1, MazeSquare.DOOR);
      maze.getLocation(5, 1).doorClosed = true;

      maze.getLocation(5, 5).keysNeeded = 999;
      maze.setContents(5, 5, MazeSquare.DOOR);
      maze.getLocation(5, 5).doorClosed = true;
      
      var doorFlip:WorldEvent = new DoorCloseEvent(maze.getLocation(2, 4));
      maze.addEventToTime(doorFlip, 25);

      doorFlip = new DoorOpenEvent(maze.getLocation(2, 4));
      maze.addEventToTime(doorFlip, 24);

      doorFlip = new DoorCloseEvent(maze.getLocation(5, 1));
      maze.addEventToTime(doorFlip, 25);

      doorFlip = new DoorOpenEvent(maze.getLocation(5, 1));
      maze.addEventToTime(doorFlip, 24);

      doorFlip = new DoorCloseEvent(maze.getLocation(5, 5));
      maze.addEventToTime(doorFlip, 25);

      doorFlip = new DoorOpenEvent(maze.getLocation(5, 5));
      maze.addEventToTime(doorFlip, 24);

      return true;
    }
  }
}

