
package TimeTravel
{
  import TimeTravel.Player;
  import TimeTravel.MazeSquare;
  import flash.filters.*;
  
  public class ObjectMoveEvent implements WorldEvent
  {
    var from:MazeSquare, to:MazeSquare;    
    var objectType:String;
    var dx:int, dy:int;

    public function ObjectMoveEvent(from:MazeSquare, to:MazeSquare, objectType:String)
    {
      this.from = from;
      this.to = to;
      this.objectType = objectType;
      dx = to.xcoord - from.xcoord;
      dy = to.ycoord - from.ycoord;
    }

    private function showWorld(completion:Number)
    {
      if (completion > 0.2)
      {
        to.setShift(-dx*(1.0-1.25*(completion-0.2)), -dy*(1.0-1.25*(completion-0.2)));
      }
      else to.setShift(-dx, -dy);
      from.setShift(-dx*(1.0-completion), -dy*(1.0-completion));
    }

    public function testWorldForward(maze:Maze):Array
    {
      if (from.contents != objectType)
      {
        return [from, from, "object-move"];
      }
      if (to.contents != MazeSquare.EMPTY)
      {
        return [from, to, "object-move"];
      }
      return null;
    }

    public function beginWorldForward(maze:Maze)
    {
      to.contentsSprite = from.contentsSprite;
      to.contents = MazeSquare.OCCUPIED;
      from.contentsSprite = null;
      from.contents = MazeSquare.OCCUPIED;
      showWorld(0.0);
    }

    public function showWorldForward(maze:Maze, completion:Number) { showWorld(completion); }

    public function endWorldForward(maze:Maze)
    {
      to.contents = objectType;
      from.contents = MazeSquare.EMPTY;
      to.blockIsLinked = from.blockIsLinked;
      from.blockIsLinked = [];
      showWorld(1.0);
    }

    public function beginWorldReverse(maze:Maze)
    {
      showWorld(1.0);
      from.contents = MazeSquare.OCCUPIED;
      to.contents = MazeSquare.OCCUPIED;
      from.blockIsLinked = to.blockIsLinked;
      to.blockIsLinked = [];
    }

    public function showWorldReverse(maze:Maze, completion:Number) { showWorld(completion); }

    public function endWorldReverse(maze:Maze)
    {
      showWorld(0.0);
      from.contentsSprite = to.contentsSprite;
      from.contents = objectType;
      to.contentsSprite = null;
      to.contents = MazeSquare.EMPTY;
    }
  }
}

