
package TimeTravel
{
  import TimeTravel.Player;
  import TimeTravel.MazeSquare;
  import flash.filters.*;
  
  public class ObjectVanishEvent implements WorldEvent
  {
    var at:MazeSquare;
    var objectType:String;
    var sprite:FilteredSprite;
    var player:Player;
    
    public function ObjectVanishEvent(at:MazeSquare, objectType:String, player:Player)
    {
      this.at = at;
      this.objectType = objectType;
      this.player = player;
      
      sprite = at.contentsSprite;
    }
    
    private function showWorld(completion:Number)
    {
      at.setBlur(int(16.0*completion));
    }

    public function testWorldForward(maze:Maze):Array
    {
      if (at.contents != objectType)
      {
        return [at, at, "vanish"];
      }
      return null;
    }

    public function beginWorldForward(maze:Maze)
    {
      at.contents = MazeSquare.OCCUPIED;
      showWorld(0.0);
    }

    public function showWorldForward(maze:Maze, completion:Number) { showWorld(completion); }

    public function endWorldForward(maze:Maze)
    {
      showWorld(1.0);
      at.contents = MazeSquare.EMPTY;
      at.contentsSprite = null;
      player.stage.removeChild(sprite);
    }

    public function beginWorldReverse(maze:Maze)
    {
      player.stage.addChild(sprite);
      at.contentsSprite = sprite;
      at.contents = MazeSquare.OCCUPIED;
      showWorld(1.0);
    }

    public function showWorldReverse(maze:Maze, completion:Number) { showWorld(completion); }

    public function endWorldReverse(maze:Maze)
    {
      showWorld(0.0);
      at.contents = objectType;
    }
  }
}

