
package TimeTravel
{
  import mx.core.SoundAsset;
  import flash.media.*;
  
  public class SoundAssets
  {
    private static var assetNames:Object = new Object();

    [Embed(source="../Sounds/Rien a faire 1.mp3")]
    private static var MenuMusicMP3:Class;
    assetNames["menu-song"] = MenuMusicMP3;
     
    [Embed(source="../Sounds/intro remix01.mp3")]
    private static var LevelMusicMP3:Class;
    assetNames["level-song"] = LevelMusicMP3;

    [Embed(source="../Sounds/Suck-Slurp2.mp3")]
    private static var TakeObjectMP3:Class;
    assetNames["take-object-sound"] = TakeObjectMP3;

    [Embed(source="../Sounds/Small Crowd Cheering.mp3")]
    private static var ApplauseMP3:Class;
    assetNames["applause"] = ApplauseMP3;

    [Embed(source="../Sounds/door_closing_2.mp3")]
    private static var CloseDoorMP3:Class;
    assetNames["close-door"] = CloseDoorMP3;

    [Embed(source="../Sounds/doorcreak.mp3")]
    private static var OpenDoorMP3:Class;
    assetNames["open-door"] = OpenDoorMP3;

    [Embed(source="../Sounds/warpwiggle.mp3")]
    private static var WarpWiggleMP3:Class;
    assetNames["warp-wiggle"] = WarpWiggleMP3;

    [Embed(source="../Sounds/adriantnt_bubble_clap.mp3")]
    private static var BubbleClapMP3:Class;
    assetNames["bubble-clap"] = BubbleClapMP3;

    [Embed(source="../Sounds/adriantnt_glass.mp3")]
    private static var GlassClickMP3:Class;
    assetNames["glass-click"] = GlassClickMP3;

    [Embed(source="../Sounds/adriantnt_release_click.mp3")]
    private static var ReleaseClickMP3:Class;
    assetNames["release-click"] = ReleaseClickMP3;

    [Embed(source="../Sounds/adriantnt_metal_hit.mp3")]
    private static var MetalHitMP3:Class;
    assetNames["metal-hit"] = MetalHitMP3;

    [Embed(source="../Sounds/adriantnt_r_plastic.mp3")]
    private static var RPlasticMP3:Class;
    assetNames["r-plastic"] = RPlasticMP3;

    [Embed(source="../Sounds/clearing-throat-2.mp3")]
    private static var ClearingThroatMP3:Class;
    assetNames["clearing-throat"] = ClearingThroatMP3;

    public static function createNamedAsset(name:String):SoundAsset
    {
      if (assetNames[name])
      {
	return SoundAsset(new assetNames[name]());
      }
      return null;
    }

    public static function playSound(name:String, volume:Number, startPos:int = 0)
    {
      var asset:SoundAsset = createNamedAsset(name);
      var st:SoundTransform = new SoundTransform(volume, 0.0);
      var sndChannel:SoundChannel = asset.play(startPos);
      sndChannel.soundTransform = st;
    }

    private static var playingSounds:Object = new Object();
    
    public static function beginPlayingSound(name:String, volume:Number, startPos:int = 0, reps:int = 1, storageName:String = null)
    {
      if (storageName == null) storageName = name;
      var asset:SoundAsset = createNamedAsset(name);
      var st:SoundTransform = new SoundTransform(volume, 0.0);
      var sndChannel:SoundChannel = asset.play(startPos, reps);
      sndChannel.soundTransform = st;
      playingSounds[storageName] = sndChannel;
    }

    public static function stopPlayingSound(name:String)
    {
      if (playingSounds[name] && (playingSounds[name] != null))
      {
	var sndChannel:SoundChannel = SoundChannel(playingSounds[name]);
	sndChannel.stop();
	playingSounds[name] = null;
      }
    }
  }
}

