
package TimeTravel
{
  import UserInterface.*;
  import flash.display.Sprite;
  import flash.display.Stage;
  import flash.events.*;
  import flash.text.*;

  public class TimeTravelMainMenu extends Sprite implements Chapter
  {
    public static var SELECTION:String = "selection";
    public static var SELECTION_START_GAME:String = "selection-start-game";
    public static var SELECTION_CONTINUE:String = "selection-continue";
    public static var SELECTION_HOW_TO_PLAY:String = "selection-how";

    public var selection:String;
    var b1:EasyButton, b2:EasyButton, b3:EasyButton;

    public function setContinueEnabled(bool:Boolean)
    {
      b2.setEnabled(bool);
    }
    
    public function TimeTravelMainMenu(stage:Stage)
    {
      addChild(new MainMenuBackground(stage));
      
      //var tf:EasyTextField = new EasyTextField("TIME TRAVELING SCIENTIST GAME", 14, 0xFF0000);
      //addChild(tf);
      //tf.setCoords(stage.stageWidth / 2, 100);
      
      var tf:FilteredSprite = Sprites.createNamedSprite("meanwhile");
      addChild(tf);
      tf.x = stage.stageWidth / 2;
      tf.y = 100;
      
      var tf2:EasyTextField = new EasyTextField("A time travel play in 2 + 1 acts", 16, 0x880000);
      addChild(tf2);
      tf2.setCoords(stage.stageWidth / 2 + 75, 125);

      b1 = new EasyButton("START GAME", 36, 0x000000, 4);
      b1.x = stage.stageWidth / 2;
      b1.y = 200;
      addChild(b1);

      b1.addEventListener(MouseEvent.CLICK, clickStartGame);

      b2 = new EasyButton("CONTINUE", 36, 0x000000, 4);
      b2.x = stage.stageWidth / 2;
      b2.y = 250;
      addChild(b2);
      b2.setEnabled(false);
      b2.addEventListener(MouseEvent.CLICK, clickContinue);

      b3 = new EasyButton("HOW TO PLAY", 36, 0x000000, 4);
      b3.x = stage.stageWidth / 2;
      b3.y = 300;
      addChild(b3);

      b3.addEventListener(MouseEvent.CLICK, clickHowToPlay);
    }

    var chapterParent:Sprite;

    public function addToParent(sprite:Sprite):void
    {
      chapterParent = sprite;
      chapterParent.addChild(this);
    }

    public function getParent():Sprite
    {
      return chapterParent;
    }

    public function getDisplay():Sprite
    {
      return this;
    }

    public function makeActive():void
    {
    }

    public function makeInactive():void
    {
    }

    public function removeFromParent():void
    {
      chapterParent.removeChild(this);
      chapterParent = null;
    }

    public function clickStartGame(event:Event)
    {
      selection = SELECTION_START_GAME;
      SoundAssets.playSound("release-click", 0.5);
      dispatchEvent(new Event(SELECTION));
    }

    public function clickContinue(event:Event)
    {
      if (b2.enabled)
      {
	selection = SELECTION_CONTINUE;
	SoundAssets.playSound("release-click", 0.5);
	dispatchEvent(new Event(SELECTION));
      }
    }

    public function clickHowToPlay(event:Event)
    {
      selection = SELECTION_HOW_TO_PLAY;
      SoundAssets.playSound("release-click", 0.5);
      dispatchEvent(new Event(SELECTION));
    }
  }
}

