
package UserInterface
{
  import flash.events.*;
  import TimeTravel.*;

  public class ChapterTransition extends EventDispatcher
  {
    public static var COMPLETE_MESSAGE:String = "transition-complete";
    var from:Chapter;
    var to:Chapter;
    var trans:SpriteTransition;
    var complete:Number = 0.0;
    var numFrames:int = 24;

    function ChapterTransition(from:Chapter, to:Chapter, trans:SpriteTransition, numFrames:int = 48)
    {
      this.from = from;
      this.to = to;
      this.trans = trans;
      this.numFrames = numFrames;
    }

    public function run()
    {
      from.makeInactive();
      to.addToParent(from.getParent());
      trans.displayTransition(from.getDisplay(), to.getDisplay(), 0.0);
      from.getParent().addEventListener(Event.ENTER_FRAME, tick);
    }

    function tick(event:Event)
    {
      complete += 1.0 / numFrames;
      if (complete > 1.0) complete = 1.0;
      trans.displayTransition(from.getDisplay(), to.getDisplay(), complete);
      if (complete < 1.0) return;
      from.getParent().removeEventListener(Event.ENTER_FRAME, tick);
      from.removeFromParent();
      to.makeActive();
      dispatchEvent(new Event(COMPLETE_MESSAGE));
    }
  }
}

