
package UserInterface
{
  import flash.display.*;
  import flash.filters.*;
  
  public class ImageButton extends SimpleButton
  {
    private var buttonWidth:int;
    private var buttonHeight:int;
    private var roundRectRadius:int;
    
    public function ImageButton(width:int, height:int, roundRectRadius:int = 10)
    {
      this.roundRectRadius = roundRectRadius;
      buttonWidth = width;
      buttonHeight = height;
      useHandCursor = true;
      upState = createUpState();
      overState = createOverState();
      downState = createDownState();
      hitTestState = createDownState();
    }

    private function createUpState():Sprite
    {
      var state:Sprite = new Sprite();
      var upShape:Shape = new Shape();
      // upShape.graphics.beginFill(0xAAAAAA);
      // upShape.graphics.drawRoundRect(0, 0, buttonWidth, buttonHeight, 10, 10);
      // upShape.graphics.endFill();
      state.addChild(upShape);
      return state;
    }
    
    private function createOverState():Sprite
    {
      var state:Sprite = new Sprite();
      var overShape:Shape = new Shape();
      // overShape.graphics.beginFill(0xAAAAAA);
      // overShape.graphics.drawRoundRect(0, 0, buttonWidth, buttonHeight, 10, 10);
      // overShape.graphics.endFill();
      overShape.graphics.lineStyle(2, 0xFF0000);
      overShape.graphics.drawRoundRect(-5, -5, buttonWidth+10, buttonHeight+10, roundRectRadius, roundRectRadius);
      state.addChild(overShape);
      return state;
    }
    
    private function createDownState():Sprite
    {
      var state:Sprite = new Sprite();
      var downShape:Shape = new Shape();
      downShape.graphics.beginFill(0xFF000000);
      downShape.graphics.drawRoundRect(-5, -5, buttonWidth+10, buttonHeight+10, roundRectRadius, roundRectRadius);
      downShape.graphics.endFill();
      
            var matrix:Array = new Array();
            matrix = matrix.concat([1, 0, 0, 0, 0]); // red
            matrix = matrix.concat([0, 1, 0, 0, 0]); // green
            matrix = matrix.concat([0, 0, 1, 0, 0]); // blue
            matrix = matrix.concat([0, 0, 0, 0.25, 0]); // alpha
            downShape.filters = [ new ColorMatrixFilter(matrix) ];

      var ds2:Shape = new Shape();
      ds2.graphics.lineStyle(2, 0xFF0000);
      ds2.graphics.drawRoundRect(-5, -5, buttonWidth+10, buttonHeight+10, roundRectRadius, roundRectRadius);
      state.addChild(downShape);
      state.addChild(ds2);
      return state;
    }
  }
}

